//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  |bvAbv\TListbox
//
//  ȉ̃TCg[Peter Below (TeamB) ̃R[h𐮔
//  http://www.delphigroups.info/2/7/325386.html
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0114 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plPopupListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Graphics, Dialogs;

type
  TplPopupListBox = class(TCustomListBox)
  private
    FCloseupEvent : TNotifyEvent;
    FDefaultDraw  : Boolean;
    FFocusRect    : Boolean;
    FSelBackColor : TColor;
    FSelFontColor : TColor;
    FDropDownRows: Integer;
    procedure SetDefaultDraw(const Value: Boolean);
    procedure SetFocusRect(const Value: Boolean);
    procedure SetSelBackColor(const Value: TColor);
    procedure SetSelFontColor(const Value: TColor);
    procedure SetDropDownRows(const Value: Integer);
  protected
    procedure CloseUp;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure DoEnter; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    function MouseIsOnScrollbar( const Pos: TPoint; var HittestCode:
    Integer): Boolean;
    function PerformNCMouseAction( Msg, HittestCode: Integer; const Pos:
    TPoint): Integer;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMLButtonDown(var Message: TWMLButtonDown);
    message WM_LBUTTONDOWN;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
      override;
    function DoMouseWheel(Shift: TShiftState; WheelDelta: Integer;
      MousePos: TPoint): Boolean; override;
  public
    procedure ShowBeneath(ALeft, ATop: Integer; AHeight: Integer=0);
    constructor Create(AOwner: TComponent); override;
    property DefaultDraw  : Boolean read FDefaultDraw write SetDefaultDraw;
    property FocusRect    : Boolean read FFocusRect write SetFocusRect;
    property SelBackColor : TColor read FSelBackColor write SetSelBackColor;
    property SelFontColor : TColor read FSelFontColor write SetSelFontColor;
    property DropDownRows : Integer read FDropDownRows write SetDropDownRows;
  published
    property WheelAccumulator;
    property OnCloseUp: TNotifyEvent read FCloseupEvent write FCloseupEvent;
    property Style;
    property AutoComplete;
    property AutoCompleteDelay;
    property Color;
    property Columns;
    property DoubleBuffered;
    property Enabled;
    property ExtendedSelect;
    property Font;
    property IntegralHeight;
    property ItemHeight;
    property Items;
    property MultiSelect;
    property ParentBiDiMode;
    property ParentColor;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ScrollWidth;
    property ShowHint;
    property Sorted;
    property TabWidth;
    property Touch;
    property OnClick;
    property OnContextPopup;
    property OnData;
    property OnDataFind;
    property OnDataObject;
    property OnDblClick;
    property OnDrawItem;
    property OnEnter;
    property OnExit;
    property OnGesture;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
  end;

procedure Register;

implementation

uses
  Forms,
  Types;

{ TplPopupListBox }

//-----------------------------------------------------------------------------
//  Create
//-----------------------------------------------------------------------------
constructor TplPopupListBox.Create(AOwner: TComponent);
begin
  inherited;
  if (csDesigning in ComponentState ) then begin
    Width  := 28;
    Height := 28;
  end else begin
    ImeMode := imDisable;
    BorderStyle := bsNone;
    Width  := 120;
    Height := 220;
    Hide;
  end;

  FDefaultDraw   :=  True;
  FFocusRect     := True;
  FSelBackColor  := $00FFD2A6;
  FSelFontColor  := clBlack;
  FDropDownRows := 8;
end;

//-----------------------------------------------------------------------------
//  CreateParams\bh
//  Rg[̃X^Cݒ
//-----------------------------------------------------------------------------
procedure TplPopupListBox.CreateParams(var Params: TCreateParams);
var
  LParentForm : TCustomForm;
begin
  inherited;

  if not (csDesigning in ComponentState ) then begin
    Params.Style := Params.Style and not WS_CHILD or WS_POPUP or WS_BORDER;

    Params.WindowClass.Style := CS_SAVEBITS or CS_DROPSHADOW;
    LParentForm := GetParentForm(Self);
    if LParentForm.Handle <> 0 then Params.WndParent := LParentForm.Handle;
  end;
end;

//-----------------------------------------------------------------------------
//  DefaultDraw vpeB̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplPopupListBox.SetDefaultDraw(const Value: Boolean);
begin
  if FDefaultDraw <> Value then begin
    FDefaultDraw := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  FocusRect vpeB̐ݒp\bh
//  tH[JX̘g`悷邩ǂ̃tO
//-----------------------------------------------------------------------------
procedure TplPopupListBox.SetFocusRect(const Value: Boolean);
begin
  if FFocusRect <> Value then begin
    FFocusRect := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  SelBackColor vpeB̐ݒp\bh
//  Is̔wiF̃vpeB̐ݒ
//  DefaultDraw vpeB̒l False ̎ɗLƂȂ
//-----------------------------------------------------------------------------
procedure TplPopupListBox.SetSelBackColor(const Value: TColor);
begin
  if FSelBackColor <> Value then begin
    FSelBackColor := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  SelFontColor vpeB̐ݒp\bh
//  Is̐̕F̃vpeB̐ݒ
//  DefaultDraw vpeB̒l False ̎ɗLƂȂ
//-----------------------------------------------------------------------------
procedure TplPopupListBox.SetSelFontColor(const Value: TColor);
begin
  if FSelFontColor <> Value then begin
@@  FSelFontColor := Value;
    Invalidate;
  end;
end;
//-----------------------------------------------------------------------------
//  DropDownCount vpeB̐ݒp\bh
//  hbv_ẼXg̍ڐ
//-----------------------------------------------------------------------------
procedure TplPopupListBox.SetDropDownRows(const Value: Integer);
begin
  if FDropDownRows <> Value then begin
    FDropDownRows := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  {R|\p̃\bh
//  X,Y(XN[W)̈ʒu\
//  AHeightw肷ƁCʉ[ŕ\ۂɁC̕ォ\
//-----------------------------------------------------------------------------
procedure TplPopupListBox.ShowBeneath(ALeft, ATop: Integer; AHeight: Integer=0);
var
  LBottom  : Integer;
  LRight   : Integer;
  LCtrlPos : TPoint;
  LMonitor : TMonitor;
begin
  if FDropDownRows >= Items.Count then FDropDownRows := Items.Count;
  if FDropDownRows <= 1 then FDropDownRows := 1;
  Height := FDropDownRows * ItemHeight + 4;

  LCtrlPos := Point(ALeft, ATop);
  // \ʒu̒
  LRight  := LCtrlPos.X + Width;
  LBottom := LCtrlPos.Y + Height;

  LMonitor := Screen.MonitorFromPoint(LCtrlPos);
  if LMonitor.WorkareaRect.Bottom < LBottom then begin
    LCtrlPos.Y := LCtrlPos.Y - AHeight - Height;
  end;
  if LMonitor.WorkareaRect.Left > LCtrlPos.X then begin
    LCtrlPos.X := LMonitor.WorkareaRect.Left;
  end else
  if LMonitor.WorkareaRect.Right < LRight then begin
    LCtrlPos.X := LMonitor.WorkareaRect.Right - Width;
  end;

  SetBounds(LCtrlPos.x, LCtrlPos.y, Width, Height);
  ItemIndex := -1;
  if Items.Count >= 1 then ItemIndex := 0;

  // TListBoxShow\bhs
  Show;

  if not Focused and CanFocus then SetFocus;
end;

//-----------------------------------------------------------------------------
//  DoEnter\bh
//  TWinControltH[JXƎIɎs
//  Show\bhŎs`Ȃ
//-----------------------------------------------------------------------------
procedure TplPopupListBox.DoEnter;
var
  LParentForm : TCustomForm;
begin
  inherited;

  // ̃R|\tH[^IɃANeBuԂɂ
  LParentForm := GetParentForm(Self);
  if LParentForm.Handle <> 0 then begin
    SendMessage(LParentForm.Handle, WM_NCACTIVATE, 1, 0);
  end;
end;

//-----------------------------------------------------------------------------
//  KeyDown\bh
//-----------------------------------------------------------------------------
procedure TplPopupListBox.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) or (Key = VK_RETURN) then begin
    if Key = VK_ESCAPE then begin
      ItemIndex := -1;
    end;
    Key := 0;
  end else
  if (Key = VK_DOWN) and (ssAlt in Shift) then begin
    Key := 0;
    CloseUp;
  end else begin
    inherited;
  end;
end;

//-----------------------------------------------------------------------------
//  KeyPress\bh
//-----------------------------------------------------------------------------
procedure TplPopupListBox.KeyPress(var Key: Char);
begin
  if Key = Char(VK_RETURN) then begin
    Closeup;
  end else
  if Key = Char(VK_ESCAPE) then begin
    ItemIndex := -1;
    Closeup;
  end else begin
    inherited;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_LBUTTONDOWNbZ[W
//-----------------------------------------------------------------------------
procedure TplPopupListBox.WMLButtonDown(var Message: TWMLButtonDown);
var
  LWhere : Integer;
  LPos   : TPoint;
begin
  LPos := Point(Message.Pos.x, Message.Pos.y);

  if MouseIsOnScrollbar(LPos, LWhere) then begin
    PerformNCMouseAction(WM_NCLBUTTONDOWN, LWhere, LPos);
  end else begin
    inherited;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_LBUTTONUPbZ[W
//-----------------------------------------------------------------------------
procedure TplPopupListBox.WMLButtonUp(var Message: TWMLButtonUp);
var
  LWhere : Integer;
  LPos   : TPoint;
begin
  LPos := Point(Message.Pos.x, Message.Pos.y);

  // XN[o[ɂꍇ
  if MouseIsOnScrollbar(LPos, LWhere) then begin
    PerformNCMouseAction(WM_NCLBUTTONUP, LWhere, LPos);
  end else begin
    inherited;
    if not MultiSelect then begin
      Closeup;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_MOUSEMOVEbZ[W
//-----------------------------------------------------------------------------
procedure TplPopupListBox.WMMouseMove(var Message: TWMMouseMove);
var
  LWhere : Integer;
  LPos   : TPoint;
begin
  LPos := Point(Message.Pos.x, Message.Pos.y);

  // XN[o[ɂꍇ
  if MouseIsOnScrollbar(LPos, LWhere) then begin
    PerformNCMouseAction(WM_NCMOUSEMOVE, LWhere, LPos);
  end else begin
    inherited;
  end;
end;

//-----------------------------------------------------------------------------
//  Pos}EXXN[o[̏ɂ邩𒲍֐
//-----------------------------------------------------------------------------
function TplPopupListBox.MouseIsOnScrollbar(const Pos: TPoint; var
  HittestCode: Integer): Boolean;
var
  LPos : TPoint;
begin
  if csDesigning In ComponentState then begin
    Result := False;
  end else begin
    LPos := Pos;
    Windows.ClientToScreen(Handle, LPos);
    Hittestcode := Perform(WM_NCHITTEST, 0, MakeLParam(LPos.X, LPos.Y));
    Result      := (Hittestcode = HTVSCROLL) or (Hittestcode = HTHSCROLL);
  end;
end;

//-----------------------------------------------------------------------------
//  e}EXCxg(bZ[W)ďoĎs֐
//  }EXXN[o[ɂꍇ́CNCAg̈Ƃđ
//-----------------------------------------------------------------------------
function TplPopupListBox.PerformNCMouseAction(Msg, HittestCode: Integer;
  const Pos: TPoint): Integer;
var
  LPos : TPoint;
begin
  LPos := Pos;
  Windows.ClientToScreen(Handle, LPos);
  Result := Perform(Msg, HittestCode, MakeLParam(LPos.X, LPos.Y));
end;

//-----------------------------------------------------------------------------
//  }EXzC[̏
//  ̏ȂƐeRg[XN[bZ[WMĂ܂
//-----------------------------------------------------------------------------
function TplPopupListBox.DoMouseWheel(Shift: TShiftState; WheelDelta: Integer;
  MousePos: TPoint): Boolean;
begin
  Result := inherited;

  if Visible and MouseInClient then begin
    if WheelDelta > 0 then begin
      Perform(WM_VSCROLL, MakeWParam(SB_LINEUP, 0), 0);
    end else begin
      Perform(WM_VSCROLL, MakeWParam(SB_LINEDOWN, 0), 0);
    end;
    // ̃EBhEɂ̓XN[bZ[W𑗐MȂ
    Result := True;
  end;
end;

//-----------------------------------------------------------------------------
//  WM_ACTIVATEbZ[W
//  {R|ANeBuɂȂ
//
//  MultiSelect=Truȅꍇ̑΍
//  MultiSelect=Falsȅꍇ̓NbNŕ̂ŕKvȂ
//-----------------------------------------------------------------------------
procedure TplPopupListBox.WMActivate(var Message: TWMActivate);
begin
  inherited;
  if Visible then begin
    if (Message.ActiveWindow <> Handle) and (Message.Active = 0) then begin
      ItemIndex := -1;
      CloseUp;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  鎞̏p֐
//-----------------------------------------------------------------------------
procedure TplPopupListBox.CloseUp;
begin
  Hide;

  // OnCloseUpCxgݒ肵ĂΎs
  if Assigned(FCloseupEvent) then begin
    FCloseupEvent(Self);
  end;

  // eRg[ɃtH[JXړ
  // eȊÕRg[ɃtH[JXꍇ͗p̃R[hőΉ
  TWinControl(Parent).SetFocus;
  SetActiveWindow(TWinControl(Parent).Handle);
end;

//-----------------------------------------------------------------------------
//  DrawItem \bh̏
//  Cxgł͑SĎȌƂȂ邪CpNX̃\bhł͎g\
//-----------------------------------------------------------------------------
procedure TplPopupListBox.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
var
  LRect      : TRect;
  LText      : string;
  LFormat    : TTextFormat;
  LTempColor : TColor;
begin
  LTempColor := Canvas.Font.Color;

  if FDefaultDraw then begin
    inherited DrawItem(Index, Rect, State);
  end else begin
    if odSelected in State then begin
      Canvas.Brush.Color := FSelBackColor;
      Canvas.Font.Color  := FSelFontColor;
    end else begin
      Canvas.Brush.Color := Color;
      Canvas.Font.Color  := clBlack;
    end;
    Canvas.FillRect(Rect);

    LRect := Rect;
    InflateRect(LRect , -3, 0);
    LText := Items[Index];
    LFormat := [tfLeft, tfVerticalCenter, tfSingleLine];
    Canvas.TextRect(LRect, LText, LFormat);
  end;
  Canvas.Font.Color := LTempColor;

  if (odFocused in State) and not FFocusRect then begin
    Canvas.DrawFocusRect(Rect);
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplPopupListBox]);
end;

end.
